classification
Title: Implement loop.sendfile
Type: enhancement Stage: resolved
Components: asyncio Versions: Python 3.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: asvetlov, giampaolo.rodola, miss-islington, vstinner, yselivanov
Priority: normal Keywords: patch

Created on 2018-01-22 15:21 by asvetlov, last changed 2019-01-08 02:15 by miss-islington. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 5271 merged asvetlov, 2018-01-22 15:22
PR 5364 merged yselivanov, 2018-01-27 20:33
PR 5367 merged asvetlov, 2018-01-27 21:04
PR 5368 merged Elvis.Pranskevichus, 2018-01-27 21:33
PR 5369 merged yselivanov, 2018-01-27 21:52
PR 5565 merged asvetlov, 2018-02-06 15:45
PR 5890 merged miss-islington, 2018-02-25 16:33
PR 7083 merged vstinner, 2018-05-23 22:38
PR 7084 closed miss-islington, 2018-05-23 22:57
PR 7086 merged vstinner, 2018-05-24 00:29
PR 11462 merged vstinner, 2019-01-08 00:55
PR 11463 merged miss-islington, 2019-01-08 01:55
Messages (19)
msg310880 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2018-01-27 19:22
New changeset 7c684073f951dd891021676ecfd86ffc18b8895e by Andrew Svetlov in branch 'master':
bpo-32622: Implement loop.sendfile() (#5271)
https://github.com/python/cpython/commit/7c684073f951dd891021676ecfd86ffc18b8895e
msg310887 - (view) Author: Yury Selivanov (yselivanov) * (Python committer) Date: 2018-01-27 20:52
New changeset b1a6ac4c4026d648b3d948945b734a4d0f175a3c by Yury Selivanov in branch 'master':
bpo-32622: Enforce sendfile fallback policy for FALLBACK transports (#5364)
https://github.com/python/cpython/commit/b1a6ac4c4026d648b3d948945b734a4d0f175a3c
msg310891 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2018-01-27 22:04
s390x Debian 3.x buildbot failed:
http://buildbot.python.org/all/#/builders/13/builds/601

Exmaple:

======================================================================
ERROR: test_sendfile_ssl_pre_and_post_data (test.test_asyncio.test_events.SelectEventLoopTests)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/home/dje/cpython-buildarea/3.x.edelsohn-debian-z/build/Lib/test/test_asyncio/test_events.py", line 2277, in test_sendfile_ssl_pre_and_post_data
    srv_proto, cli_proto = self.prepare(is_ssl=True)
  File "/home/dje/cpython-buildarea/3.x.edelsohn-debian-z/build/Lib/test/test_asyncio/test_events.py", line 2136, in prepare
    srv_ctx = test_utils.simple_server_sslcontext()
  File "/home/dje/cpython-buildarea/3.x.edelsohn-debian-z/build/Lib/test/test_asyncio/utils.py", line 73, in simple_server_sslcontext
    server_context = ssl.SSLContext(ssl.PROTOCOL_TLS_SERVER)
AttributeError: 'NoneType' object has no attribute 'SSLContext'
msg310892 - (view) Author: Yury Selivanov (yselivanov) * (Python committer) Date: 2018-01-27 22:04
> AttributeError: 'NoneType' object has no attribute 'SSLContext'

We've just pushed a fix for this.
msg310893 - (view) Author: Yury Selivanov (yselivanov) * (Python committer) Date: 2018-01-27 22:11
New changeset ee72ac0683e685b134f67cb0c6612c664ecadb65 by Yury Selivanov (Elvis Pranskevichus) in branch 'master':
bpo-32622: Fix AbstractEventLoop.sendfile signature in documentation. (GH-5368)
https://github.com/python/cpython/commit/ee72ac0683e685b134f67cb0c6612c664ecadb65
msg310896 - (view) Author: Yury Selivanov (yselivanov) * (Python committer) Date: 2018-01-27 22:22
New changeset 2a2247ce5e1984eb2f2c41b269b38dbb795a60cf by Yury Selivanov in branch 'master':
bpo-32622: Normalize ENOTCONN to ConnectionError on macOS (GH-5369)
https://github.com/python/cpython/commit/2a2247ce5e1984eb2f2c41b269b38dbb795a60cf
msg310897 - (view) Author: Yury Selivanov (yselivanov) * (Python committer) Date: 2018-01-27 22:44
I think we've fixed everything. Closing this for now, Victor please reopen if buildbots misbehave.
msg311105 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2018-01-29 12:09
New asyncio sendfile tests fail on many buildbots. See:
https://bugs.python.org/issue32645#msg311101
msg311108 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2018-01-29 12:17
I pretty sure it's fixed by https://github.com/python/cpython/commit/0f54e00e963
msg311114 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2018-01-29 12:35
test_sendfile() hangs on AMD64 FreeBSD 10.x Shared 3.x buildbot: bpo-32708.
msg311123 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2018-01-29 12:58
ProactorEventLoopTests.test_sendfile_close_peer_in_middle_of_receiving() leaks a reference on Windows: bpo-32710.
msg312820 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2018-02-25 16:32
New changeset a19fb3c6aaa7632410d1d9dcb395d7101d124da4 by Andrew Svetlov in branch 'master':
bpo-32622: Native sendfile on windows (#5565)
https://github.com/python/cpython/commit/a19fb3c6aaa7632410d1d9dcb395d7101d124da4
msg312822 - (view) Author: miss-islington (miss-islington) Date: 2018-02-25 17:11
New changeset 632c1cb57176d268d65a9fd7b00582f32e0884ee by Miss Islington (bot) in branch '3.7':
bpo-32622: Native sendfile on windows (GH-5565)
https://github.com/python/cpython/commit/632c1cb57176d268d65a9fd7b00582f32e0884ee
msg317471 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2018-05-23 22:56
New changeset 2932755cc11fd82b4908d60b24b837aa4f3028e6 by Victor Stinner in branch 'master':
bpo-33353: test_asyncio uses smaller sendfile data (#7083)
https://github.com/python/cpython/commit/2932755cc11fd82b4908d60b24b837aa4f3028e6
msg317484 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2018-05-24 00:43
New changeset b97de3dd86046ac46567146d86a69d4f78ea09db by Victor Stinner in branch 'master':
bpo-33353: test_asyncio set SO_SNDBUF after connect (GH-7086)
https://github.com/python/cpython/commit/b97de3dd86046ac46567146d86a69d4f78ea09db
msg317490 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2018-05-24 01:21
New changeset fa24c1c5afa9ba2453d88db5ed6b9d2cc3b58384 by Victor Stinner in branch '3.7':
[3.7] bpo-33353: Fix test_asyncio on FreeBSD (GH-7087)
https://github.com/python/cpython/commit/fa24c1c5afa9ba2453d88db5ed6b9d2cc3b58384
msg318043 - (view) Author: Yury Selivanov (yselivanov) * (Python committer) Date: 2018-05-29 15:15
Closing this issue. Open new ones to track regressions/bugs.
msg333196 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-01-08 01:47
New changeset 80fda712c83f5dd9560d42bf2aa65a72b18b7759 by Victor Stinner in branch 'master':
bpo-35682: Fix _ProactorBasePipeTransport._force_close() (GH-11462)
https://github.com/python/cpython/commit/80fda712c83f5dd9560d42bf2aa65a72b18b7759
msg333201 - (view) Author: miss-islington (miss-islington) Date: 2019-01-08 02:15
New changeset 88bd26a72eb4ab341cf19bea78a0039fbe4be3a2 by Miss Islington (bot) in branch '3.7':
bpo-35682: Fix _ProactorBasePipeTransport._force_close() (GH-11462)
https://github.com/python/cpython/commit/88bd26a72eb4ab341cf19bea78a0039fbe4be3a2
History
Date User Action Args
2019-01-08 02:15:28miss-islingtonsetmessages: + msg333201
2019-01-08 01:55:06miss-islingtonsetpull_requests: + pull_request10949
2019-01-08 01:47:11vstinnersetmessages: + msg333196
2019-01-08 00:55:55vstinnersetpull_requests: + pull_request10944
2018-05-29 15:15:47yselivanovsetstatus: open -> closed
resolution: fixed
messages: + msg318043

stage: patch review -> resolved
2018-05-24 01:21:16vstinnersetmessages: + msg317490
2018-05-24 00:43:49vstinnersetmessages: + msg317484
2018-05-24 00:29:00vstinnersetpull_requests: + pull_request6720
2018-05-23 22:57:25miss-islingtonsetpull_requests: + pull_request6717
2018-05-23 22:56:12vstinnersetmessages: + msg317471
2018-05-23 22:38:58vstinnersetpull_requests: + pull_request6715
2018-05-23 13:06:27giampaolo.rodolasetnosy: + giampaolo.rodola
2018-02-25 17:11:00miss-islingtonsetnosy: + miss-islington
messages: + msg312822
2018-02-25 16:33:23miss-islingtonsetpull_requests: + pull_request5661
2018-02-25 16:32:16asvetlovsetmessages: + msg312820
2018-02-06 15:45:22asvetlovsetstage: resolved -> patch review
pull_requests: + pull_request5387
2018-01-29 12:58:01vstinnersetmessages: + msg311123
2018-01-29 12:35:51vstinnersetmessages: + msg311114
2018-01-29 12:17:37asvetlovsetmessages: + msg311108
2018-01-29 12:09:34vstinnersetstatus: closed -> open
resolution: fixed -> (no value)
messages: + msg311105
2018-01-27 22:44:53yselivanovsetstatus: open -> closed
resolution: fixed
messages: + msg310897
2018-01-27 22:22:03yselivanovsetmessages: + msg310896
2018-01-27 22:11:12yselivanovsetmessages: + msg310893
2018-01-27 22:04:44yselivanovsetmessages: + msg310892
2018-01-27 22:04:13vstinnersetstatus: closed -> open

nosy: + vstinner
messages: + msg310891

resolution: fixed -> (no value)
2018-01-27 21:52:37yselivanovsetpull_requests: + pull_request5212
2018-01-27 21:33:22Elvis.Pranskevichussetpull_requests: + pull_request5211
2018-01-27 21:04:37asvetlovsetpull_requests: + pull_request5210
2018-01-27 20:52:54yselivanovsetmessages: + msg310887
2018-01-27 20:33:14yselivanovsetpull_requests: + pull_request5208
2018-01-27 20:11:41yselivanovsetstatus: open -> closed
type: enhancement
resolution: fixed
stage: patch review -> resolved
2018-01-27 19:22:49asvetlovsetmessages: + msg310880
2018-01-22 15:22:52asvetlovsetkeywords: + patch
stage: patch review
pull_requests: + pull_request5115
2018-01-22 15:21:57asvetlovcreate